SystemOrganization addCategory: #'Artefact-Tests'!
SystemOrganization addCategory: 'Artefact-Tests-Base'!
SystemOrganization addCategory: 'Artefact-Tests-DataTypes'!
SystemOrganization addCategory: 'Artefact-Tests-Elements'!
SystemOrganization addCategory: 'Artefact-Tests-Formats'!
SystemOrganization addCategory: 'Artefact-Tests-Generator'!
SystemOrganization addCategory: 'Artefact-Tests-Layouts'!
SystemOrganization addCategory: 'Artefact-Tests-Regression'!

TestCase subclass: #PDFBasicTest
	instanceVariableNames: 'element'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Base'!

!PDFBasicTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 11/16/2012 10:46'!
element
	^ element! !

!PDFBasicTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 11/16/2012 10:46'!
element: anObject
	element := anObject! !

!PDFBasicTest methodsFor: 'running' stamp: 'GuillaumeLarcheveque 5/17/2013 11:06'!
setUp
	self element: PDFDummyBasic new.! !

!PDFBasicTest methodsFor: 'tests' stamp: 'OlivierAuverlot 11/16/2012 10:45'!
testSplitCoordinates
	self assert: (self element splitCoordinates: 20@30) = '20 30'.! !

TestCase subclass: #PDFColorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Base'!

!PDFColorTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 5/17/2013 11:23'!
testEqual
	self assert: (PDFColor r: 12 g: 48 b: 79) equals: (PDFColor r: 12 g: 48 b: 79)! !

!PDFColorTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 5/17/2013 11:23'!
testEqualDifferents
	self deny: (PDFColor r: 54 g: 98 b: 12) = (PDFColor r: 12 g: 48 b: 79)! !

TestCase subclass: #PDFDataTypeTest
	instanceVariableNames: 'aStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-DataTypes'!

!PDFDataTypeTest methodsFor: 'utilities' stamp: 'guillaumelarcheveque 12/14/2012 14:04'!
assert: aPDFDataType print: aString
	aPDFDataType printOn: aStream.
	self assert: aStream contents equals: aString! !

!PDFDataTypeTest methodsFor: 'running' stamp: 'guillaumelarcheveque 12/14/2012 13:53'!
setUp
	aStream := WriteStream on: ''.! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:19'!
testDataArray
	| dataArray |
	dataArray := PDFDataArray new.
	dataArray addElement: (PDFDataValue value: 0).
	dataArray addElement: (PDFDataValue value: 0).
	dataArray addElement: (PDFDataValue value: 595.3).
	dataArray addElement: (PDFDataValue value: 841.9).
	self assert: dataArray print: '[ 0 0 595.3 841.9 ]'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:20'!
testDataArrayEmpty
	self assert: (PDFDataArray new) print: '[ ]'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:23'!
testDataArrayReferencies
	| dataArray |
	dataArray := PDFDataArray new.
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 2; revision: 0; yourself)).
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 5; revision: 0; yourself)).
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 8; revision: 0; yourself)).
	self assert: dataArray print: '[ 2 0 R 5 0 R 8 0 R ]'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:21'!
testDataArraySymbols
	| dataArray |
	dataArray := PDFDataArray new.
	dataArray addElement: (PDFDataSymbol symbol: 'PDF').
	dataArray addElement: (PDFDataSymbol symbol: 'Text').
	dataArray addElement: (PDFDataSymbol symbol: 'ImageC').
	self assert: dataArray print: '[ /PDF /Text /ImageC ]'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 4/26/2013 10:08'!
testDataAssociativeArray
	| dataAssociativeArray dataArray |
	dataArray := PDFDataArray new.
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 2; revision: 0; yourself)).
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 5; revision: 0; yourself)).
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 8; revision: 0; yourself)).
	
	dataAssociativeArray := PDFDataAssociativeArray new.
	dataAssociativeArray add:( PDFDataCouple key: (PDFDataSymbol symbol: 'Type') value: (PDFDataSymbol symbol: 'Pages' )).
	dataAssociativeArray add:( PDFDataCouple key:  (PDFDataSymbol symbol: 'Kids') value: dataArray).
	dataAssociativeArray add:( PDFDataCouple key:  (PDFDataSymbol symbol: 'Count') value: (PDFDataValue value: 3)).
	
	self assert: dataAssociativeArray print: '<<',String lf, '/Type /Pages',String lf, '/Kids [ 2 0 R 5 0 R 8 0 R ]',String lf, '/Count 3',String lf, '>>'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 1/11/2013 10:14'!
testDataComment
	self assert: (PDFDataComment text: 'PDF-1.3') print: '%PDF-1.3'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 1/11/2013 11:33'!
testDataCouple
	|  couple dataArray |
	dataArray := PDFDataArray new.
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 2; revision: 0; yourself)).
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 5; revision: 0; yourself)).
	dataArray addElement: (PDFDataReference reference: (PDFDataObject new id: 8; revision: 0; yourself)).
	
	couple:= PDFDataCouple key: (PDFDataSymbol symbol: 'Kids') value: dataArray.
	
	self assert: couple print: '/Kids [ 2 0 R 5 0 R 8 0 R ]'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:12'!
testDataReference
	self assert: (PDFDataReference reference: (PDFDataObject new id: 42; revision: 0; yourself)) print: '42 0 R'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'OlivierAuverlot 2/7/2013 20:54'!
testDataString
	self assert: (PDFDataString text: 'a string') print: '(a string)'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:08'!
testDataSymbol
	self assert: (PDFDataSymbol symbol: 'Type') print: '/Type'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:06'!
testDataValueEmptyString
	self assert: (PDFDataValue value: '') print: ''! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:06'!
testDataValueNumber
	self assert: (PDFDataValue value: 12) print: '12'! !

!PDFDataTypeTest methodsFor: 'tests' stamp: 'guillaumelarcheveque 12/14/2012 14:07'!
testDataValueString
	self assert: (PDFDataValue value: 'Olivier') print: 'Olivier'! !

TestCase subclass: #PDFDemosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Base'!

!PDFDemosTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 4/26/2013 11:06'!
testAllDemos
	| demos |
	demos := PDFDemos new.
	PDFDemos methods do: [ :m | demos perform: m selector with: (MultiByteBinaryOrTextStream on: String new) ]! !

TestCase subclass: #PDFDocumentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests'!

!PDFDocumentTest methodsFor: 'tests' stamp: 'AntoanHristov 3/10/2017 15:11'!
testSetDate
	| a dateTest |
	dateTest := Date fromString: '02.17.2017'.
	a := PDFDocument new.
	a metaData date: dateTest.
	self assert: a metaData date equals: dateTest! !

!PDFDocumentTest methodsFor: 'tests' stamp: 'AntoanHristov 3/10/2017 15:07'!
testSetTime
	| a timeTest |
	timeTest := Time fromString: '5:19:45 pm'.
	a := PDFDocument new.
	a metaData time: timeTest.
	self assert: a metaData time equals: timeTest! !

TestCase subclass: #PDFElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Elements'!

!PDFElementTest methodsFor: 'tests orientation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:41'!
testOrientationBottomLeft
	self assert: (PDFElement determineOrientation: -20 mm @ 10mm) equals: #bottomLeft! !

!PDFElementTest methodsFor: 'tests orientation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:40'!
testOrientationBottomRight
	self assert: (PDFElement determineOrientation: 20 mm @ 10mm) equals: #bottomRight! !

!PDFElementTest methodsFor: 'tests orientation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:42'!
testOrientationDefaultCase
	self assert: (PDFElement determineOrientation: 0 mm @ 0 mm) equals: #bottomRight! !

!PDFElementTest methodsFor: 'tests orientation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:41'!
testOrientationTopLeft
	self assert: (PDFElement determineOrientation: -20 mm @ -10mm) equals: #topLeft! !

!PDFElementTest methodsFor: 'tests orientation' stamp: 'GuillaumeLarcheveque 5/24/2013 15:40'!
testOrientationTopRight
	self assert: (PDFElement determineOrientation: 20 mm @ -10mm) equals: #topRight! !

!PDFElementTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 5/24/2013 18:54'!
testRequiredAttributesIsFilled
	self shouldnt: [(PDFDummyLayout new from: 10mm@5mm; dimension: 5cm@12cm) checkAttributes] raise: ArtefactUndefinedAttribute ! !

!PDFElementTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 5/24/2013 18:52'!
testRequiredAttributesIsNotFilled
	self should: [PDFDummyLayout new checkAttributes] raise: ArtefactUndefinedAttribute ! !

TestCase subclass: #PDFFontTest
	instanceVariableNames: 'doc page'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Base'!

!PDFFontTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/21/2012 15:27'!
doc
	^ doc! !

!PDFFontTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/21/2012 15:27'!
doc: anObject
	doc := anObject! !

!PDFFontTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/21/2012 15:27'!
page
	^ page! !

!PDFFontTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/21/2012 15:27'!
page: anObject
	page := anObject! !

!PDFFontTest methodsFor: 'running' stamp: 'OlivierAuverlot 3/21/2012 15:28'!
setUp
	self doc: PDFDocument new.! !

!PDFFontTest methodsFor: 'running' stamp: 'OlivierAuverlot 3/21/2012 15:13'!
tearDown ! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/8/2013 18:41'!
testCourierBIWidth
	self
		assert:
			(PDFCourierFont new
				fontSize: 16 pt;
				bold: true;
				italic: true;
				getStringWidth: 'hello')
		equals: 48 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/8/2013 18:31'!
testCourierBWidth
	self
		assert:
			(PDFCourierFont new
				fontSize: 16 pt;
				bold: true;
				getStringWidth: 'hello')
		equals: 48 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/8/2013 18:32'!
testCourierIWidth
	self
		assert:
			(PDFCourierFont new
				fontSize: 16 pt;
				italic: true;
				getStringWidth: 'hello')
		equals: 48 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/8/2013 18:32'!
testCourierWidth
	self
		assert:
			(PDFCourierFont new
				fontSize: 16 pt;
				getStringWidth: 'hello')
		equals: 48 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:23'!
testHelveticaBIWidth
	self
		assert:
			(PDFHelveticaFont new
				fontSize: 16 pt;
				bold: true;
				italic: true;
				getStringWidth: 'hello') rounded
		equals: 37 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:23'!
testHelveticaBWidth
	self
		assert:
			(PDFHelveticaFont new
				fontSize: 16 pt;
				bold: true;
				getStringWidth: 'hello') rounded
		equals: 37 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:23'!
testHelveticaIWidth
	self
		assert:
			(PDFHelveticaFont new
				fontSize: 16 pt;
				italic: true;
				getStringWidth: 'hello') rounded
		equals: 34 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:23'!
testHelveticaWidth
	self
		assert:
			(PDFHelveticaFont new
				fontSize: 16 pt;
				getStringWidth: 'hello') rounded
		equals: 34 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:23'!
testSymbolWidth
	self
		assert:
			(PDFSymbolFont new
				fontSize: 16 pt;
				getStringWidth: 'hello') rounded
		equals: 43 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:23'!
testTimesBIWidth
	self
		assert:
			(PDFTimesFont new
				fontSize: 16 pt;
				bold: true;
				italic: true;
				getStringWidth: 'hello') rounded
		equals: 33 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:24'!
testTimesBWidth
	self
		assert:
			(PDFTimesFont new
				fontSize: 16 pt;
				bold: true;
				getStringWidth: 'hello') rounded
		equals: 33 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:24'!
testTimesIWidth
	self
		assert:
			(PDFTimesFont new
				fontSize: 16 pt;
				italic: true;
				getStringWidth: 'hello') rounded
		equals: 32 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/15/2013 11:24'!
testTimesWidth
	self
		assert:
			(PDFTimesFont new
				fontSize: 16 pt;
				getStringWidth: 'hello') rounded
		equals: 32 pt! !

!PDFFontTest methodsFor: 'fontsWidth' stamp: 'GuillaumeLarcheveque 3/8/2013 18:40'!
testZapfdingbatsWidth
	self
		assert:
			(PDFZapfdingbatsFont new
				fontSize: 16 pt;
				getStringWidth: 'hello') rounded
		equals: 61 pt! !

TestCase subclass: #PDFFormatsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Formats'!

!PDFFormatsTest commentStamp: 'AntoanHristov 2/10/2017 15:55' prior: 0!
In this test we tested the default values of margins size and portrait for all of kind of formats
!

!PDFFormatsTest methodsFor: 'tests' stamp: 'AntoanHristov 2/10/2017 16:02'!
testInitializedWithDefaultValues

	PDFFormat allSubclasses do: [ :formatClass |
		| formatPDF |
		formatPDF := formatClass new.
		self assert: formatPDF  margins equals: formatPDF defaultMargins .
		self assert: formatPDF size equals: formatPDF defaultSize .
		self assert: formatPDF portrait.
		 ]! !

TestCase subclass: #PDFGenerationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Regression'!

!PDFGenerationTest methodsFor: 'helpers' stamp: 'AntoanHristov 3/17/2017 14:13'!
compareContentsOf: aFileReference withContentsOf: aFileReference2 
	
	| linesFile1 linesFile2 |
	linesFile1 := (aFileReference readStream
		converter: Latin1TextConverter new;
		contents) lines.
	linesFile2 := (aFileReference2 readStream
		converter: Latin1TextConverter new;
		contents) lines.
	
	linesFile1 withIndexDo: [ :line :index |
		self assert: line = (linesFile2 at: index) ]! !

!PDFGenerationTest methodsFor: 'helpers' stamp: 'AntoanHristov 3/17/2017 13:55'!
differignFilesBetween: folder1 With: folder2 
	
	| folderArray1 folder2FileReference doc2 |
	folderArray1 := folder1 asFileReference children.
	folder2FileReference := folder2 asFileReference.
	^ folderArray1
		select: [ :doc1 | 
			doc2 := folder2FileReference / doc1 basename.
			doc1 readStream binary contents ~= doc2 readStream binary contents ]! !

!PDFGenerationTest methodsFor: 'tests' stamp: 'AntoanHristov 3/17/2017 13:48'!
testDifferentDates: folder1 With: folder2
	"return the result of the comparaison to pdfs from folder1 with pdfs from folder2 "

	| folderArray1 folder2FileReference doc2 |
	folderArray1 := folder1 asFileReference children.
	folder2FileReference := folder2 asFileReference.
	folderArray1
		do: [ :doc1 | 
			doc2 := folder2FileReference / doc1 basename.
			self assert: doc1 readStream binary contents equals: doc2 readStream binary contents ]! !

!PDFGenerationTest methodsFor: 'tests' stamp: 'AntoanHristov 3/17/2017 14:14'!
testDifferentDatesOK2
	"We suppose destinationFolder2 is created by the method of creation of demos to a precise date and time"

	| destination1 destination2 date time files |
	destination1 := 'destination1'.
	destination2 := 'destination2'.
	destination1 asFileReference ensureDeleteAll.
	destination2 asFileReference ensureDeleteAll.
	
	date := Date today.
	time := Time now.
	PDFDemos new demosWithDate: date AndTime: time destination: destination1.
	PDFDemos new demosWithDate: date AndTime: time destination: destination2.

	files := self differignFilesBetween: destination1 With: destination2.	

	self assert: files isEmpty.! !

TestCase subclass: #PDFGeneratorTest
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Generator'!

!PDFGeneratorTest methodsFor: 'running' stamp: 'guillaumelarcheveque 1/11/2013 11:17'!
setUp
	generator := PDFGenerator new.! !

!PDFGeneratorTest methodsFor: 'tests' stamp: 'OlivierAuverlot 1/24/2014 09:16'!
testGenerateEmptyPage
	| page pageDataType contentDataType document |
	document := PDFDocument new uncompressed.
	page := PDFPage new format: PDFA4Format new.
	document add: page.
	generator := PDFGenerator new compression: false.
	generator generatePDFDocument: PDFDocument new.
	pageDataType := generator generatePDFPage: page.
	self assert: pageDataType class equals: PDFDataObject.
	self assert: pageDataType id equals: 2.
	self assert: pageDataType revision equals: 0.
	self assert: pageDataType contents first class equals: PDFDataAssociativeArray.
	"
	contentDataType := pageDataType contents first associativeArray fourth value.
	self assert: contentDataType class equals: PDFDataReference.
	self assert: contentDataType referencedObject id equals: 3.
	self assert: contentDataType referencedObject revision equals: 0
	"! !

!PDFGeneratorTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 3/2/2013 12:20'!
testGenerateFontID
	self assert: generator generateFontId equals: 'F1'.
	self assert: generator generateFontId equals: 'F2'.
	self assert: generator generateFontId equals: 'F3'! !

!PDFGeneratorTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 4/26/2013 10:13'!
testGeneratePDFFormat
	| dataType format elements |
	format := PDFA3Format new setLandscape.
	dataType := generator generatePDFFormat: format.
	self assert: dataType class equals: PDFDataCouple.
	self assert: dataType key class equals: PDFDataSymbol.
	self assert: dataType key symbol equals: 'MediaBox'.
	self assert: dataType value class equals: PDFDataArray.
	elements := dataType value elements.
	self assert: (elements first value closeTo: 0).
	self assert: (elements second value closeTo: 0).
	self assert: (elements third value pt closeTo: format width).
	self assert: (elements fourth value pt closeTo: format height)! !

!PDFGeneratorTest methodsFor: 'tests' stamp: 'OlivierAuverlot 2/1/2013 10:27'!
testGeneratePDFVersion
	| dataType version |
	version := '1.3'.
	dataType:= generator generatePDFVersion: version.
	self assert: dataType class equals: PDFDataComment.! !

TestCase subclass: #PDFHorizontalLayoutTest
	instanceVariableNames: 'testLayout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Layouts'!

!PDFHorizontalLayoutTest methodsFor: 'running' stamp: 'GuillaumeLarcheveque 3/20/2013 11:28'!
setUp 
	testLayout := PDFHorizontalLayout new! !

!PDFHorizontalLayoutTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 5/24/2013 13:50'!
testPosition
	| rect line |
	rect := PDFRectElement from: 10 mm @ 10 mm dimension: 10 cm @ 3 cm.
	line := PDFLineElement from: 50 mm @ 15 mm dimension: 24 mm @ 56 mm.
	testLayout
		from: 34 mm @ 78 mm;
		add: rect;
		add: line.
	testLayout defineElementPosition: rect with: nil styleSheet: nil.
	testLayout defineElementPosition: line with: nil styleSheet: nil.
	self assert: rect from equals: 34 mm @ 78 mm.
	self assert: line from equals: (34 mm + 10 cm + testLayout spacing) @ 78 mm! !

TestCase subclass: #PDFLayoutTest
	instanceVariableNames: 'testLayout generator page document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Elements'!

!PDFLayoutTest methodsFor: 'running' stamp: 'GuillaumeLarcheveque 3/20/2013 13:55'!
setUp 
	testLayout := PDFDummyLayout new.
	generator := PDFGenerator new.
	page := PDFPage new.
	document := PDFDocument new.
	document add: page.
	generator currentPage: page.! !

!PDFLayoutTest methodsFor: 'tests' stamp: 'GuillaumeLarcheveque 3/4/2015 13:04'!
testLayoutDoNotLoseOriginalDimensionOfElements
	| rect rect2 |
	rect := PDFRectElement from: 10 mm @ 10 mm dimension: 10 cm @ 3 cm.
	rect2 := PDFRectElement from: 50 mm @ 15 mm dimension: 24 mm @ 56 mm.
	testLayout
		from: 34 mm @ 78 mm;
		add: rect;
		add: rect2.
	testLayout generateCodeSegmentsCollectionWith: generator styleSheet: StyleSheet default format: (PDFA4Format new).
	self assert: rect dimension equals: 10 cm @ 3 cm.
	self assert: rect2 dimension equals: 24 mm @ 56 mm! !

TestCase subclass: #PDFParagraphTest
	instanceVariableNames: 'doc page paragraph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Base'!

!PDFParagraphTest commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State a one line summary. For example, "I represent a paragraph of text".

For the Responsibility part: Three sentences about my main responsibilities - what I do, what I know.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- (for bonus points) how to create instances.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	doc:		<Object>
	page:		<Object>
	paragraph:		<Object>


    Implementation Points!

!PDFParagraphTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/23/2012 09:40'!
doc
	^ doc! !

!PDFParagraphTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/23/2012 09:40'!
doc: anObject
	doc := anObject! !

!PDFParagraphTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/23/2012 09:40'!
page
	^ page! !

!PDFParagraphTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/23/2012 09:40'!
page: anObject
	page := anObject! !

!PDFParagraphTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/23/2012 09:40'!
paragraph
	^ paragraph! !

!PDFParagraphTest methodsFor: 'accessing' stamp: 'OlivierAuverlot 3/23/2012 09:40'!
paragraph: anObject
	paragraph := anObject! !

!PDFParagraphTest methodsFor: 'running' stamp: 'GuillaumeLarcheveque 5/24/2013 13:55'!
setUp
	self doc: PDFDocument new.
	self page: PDFPage new.
	
	self paragraph: (PDFParagraphElement new 
		from: 10mm@10mm;
		dimension: 160mm@60mm; 
		text: 'Emensis itaque difficultatibus multis et nive obrutis callibus plurimis ubi prope Rauracum ventum est ad supercilia fluminis Rheni, resistente multitudine Alamanna pontem suspendere navium conpage Romani vi nimia vetabantur ritu grandinis undique convolantibus telis, et cum id inpossibile videretur, imperator cogitationibus magnis attonitus, quid capesseret ambigebat.').
		
	self page add: self paragraph.
	self doc add: self page.
	
	self doc generate.! !

!PDFParagraphTest methodsFor: 'running' stamp: 'OlivierAuverlot 3/23/2012 09:33'!
tearDown ! !

TestCase subclass: #PDFRegressionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Regression'!

!PDFRegressionTest methodsFor: 'tests' stamp: 'AntoanHristov 3/17/2017 13:44'!
testDifferentDates: folder1 With: folder2
	"return the result of the comparaison to pdfs from folder1 with pdfs from folder2 "

	| folderArray1 folder2FileReference doc2 |
	folderArray1 := folder1 asFileReference children.
	folder2FileReference := folder2 asFileReference.
	folderArray1
		do: [ :doc1 | 
			doc2 := folder2FileReference / doc1 basename.
			doc1 readStream binary contents = doc2 readStream binary contents
				ifFalse: [ ^ false ] ].
	^ true! !

!PDFRegressionTest methodsFor: 'tests' stamp: 'AntoanHristov 3/13/2017 17:07'!
testDifferentDatesOK
	"Test two folders with different contents"

	| result |
	result := self testDifferentDates: 'destinationFolder' With: 'pdfWithDateAndTime'.
	self assert: result equals: false! !

!PDFRegressionTest methodsFor: 'tests' stamp: 'AntoanHristov 3/17/2017 09:04'!
testDifferentDatesOK2
	"We suppose destinationFolder2 is created by the method of creation of demos to a precise date and time"

	| result |
	result := self testDifferentDates: 'pdfWithDateAndTime' With: 'folder2'.
	self assert: result equals: true! !

TestCase subclass: #PDFStreamPrinterTest
	instanceVariableNames: 'aStream printer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Generator'!

!PDFStreamPrinterTest methodsFor: 'tests compression' stamp: 'OlivierAuverlot 4/11/2013 22:53'!
testGenerateGZipCompression
	| result |
	
	result := OrderedCollection new.
	
	(PDFStreamPrinter new compressWithGZip: 'hello') do: [ :byte | result add: byte asInteger ].

	self assert: result equals: #( 120 156 203 72 205 201 201 7 0 6 44 2 21) asOrderedCollection ! !

PDFBasic subclass: #PDFDummyBasic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Base'!

!PDFDummyBasic commentStamp: '<historical>' prior: 0!
A PDFDummyBasic is a dummy element for testing.

Instance Variables
!

!PDFDummyBasic methodsFor: 'style' stamp: 'AntoanHristov 2/3/2017 14:53'!
defaultStyle
 	^ #default! !

PDFLayout subclass: #PDFDummyLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Artefact-Tests-Elements'!

!PDFDummyLayout commentStamp: '<historical>' prior: 0!
A PDFDummyLayout is a dummy layout used for PDFLayoutTest.

Instance Variables
!

!PDFDummyLayout methodsFor: 'layouting' stamp: 'GuillaumeLarcheveque 5/24/2013 13:55'!
defineElementDimension: anElement with: aPDFGenerator styleSheet: aStyleSheet
	anElement dimension: 10pt @ 10pt! !

!PDFDummyLayout methodsFor: 'layouting' stamp: 'GuillaumeLarcheveque 3/20/2013 13:48'!
defineElementPosition: anElement with: aPDFGenerator styleSheet: aStyleSheet
	anElement from: 10pt @ 10pt! !
